//What are you doing here?!?! Hehe, well this is a possible upcoming feature if you can read what I'm going for

datablock playerData(minerStandardArmor : playerStandardArmor)
{
	uiName = "Miner";
	ridable = true;
};

function serverCmdBuyItem(%client,%itemID)
{
	if(isObject(%client.player))
	{
		initContainerRadiusSearch(%client.player.getPosition,5,$TypeMasks::playerObjectType);
		while((%obj = containerSearchNext()) != 0)
		{
			if(%obj.getClassname() $= "AIPlayer")
			{
				if(%obj.getDatablock().getName() $= "minerStandardArmor")
				{
					%allClear = 1;
					break;
				}
			}
		}
		if(!%allClear)
		{
			return;
		}
		switch(%itemID)
		{
			case 1:
				%image = TrenchClusterImage;
			default:
				messageClient(%client,'',"\c3Miner\c6: Sorry, I don't have an item with that ID!");
				return;
		}

		%client.player.addItem(%image,%client);
		
	}
}

package MinerAI
{
	function Player::activateStuff(%this)
	{
		Parent::activateStuff(%this);
		%eyePoint = %this.getEyePoint();
		%eyeVector = %this.getEyeVector();
		%typemasks = $TypeMasks::fxBrickObjectType | $TypeMasks::PlayerObjectType;
		%raycast = containerRayCast(%eyePoint,vectorAdd(%eyePoint,vectorScale(%eyeVector,4)),%typemasks,%this);
		%obj = firstWord(%raycast);
		lilDebug("Raycast is "@%raycast);
		if(isObject(%obj))
		{
			if(%obj.getClassname() $= "AIPlayer")
			{
				if(%obj.getDatablock().getName() $= "minerStandardArmor")
				{
					%obj.setMoveObject(0);
					%obj.setAimObject(%this);
					%obj.schedule(500,"playThread","talk",3);
					%obj.schedule(1500,"playThread","root",3);

					schedule(500,0,"messageClient",%this.client,'',"\c3Miner\c6: Hello, would you like to purchase any of my merchandise?");
					schedule(550,0,"messageClient",%this.client,'',"\c3Miner\c6: You may type /trenchHelp to learn how to buy items");
					%this.client.schedule(550,"listTrenchItems");
				}
			}
		}
	}

	function GameConnection::autoAdminCheck(%client)
	{
		%parent = Parent::autoAdminCheck(%client);
		if(!TrenchDigSO.keyExists(%client.getBLID()))
		{
			TrenchDigSO.addKey(%client.getBLID());
		}
	}

	function fxDTSBrick::spawnVehicle(%this)
	{
		parent::spawnVehicle(%this);
		%this.schedule(33,"spawnMinerBot");
	}
};
activatePackage(MinerAI);

function GameConnection::listTrenchItems(%this)
{
	%currPouchLevel = %this.pouchLevel;
	%nextPouchLevel = %currPouchLevel + 1;
	%upgradeCost = %nextPouchLevel * 50;

	messageClient(%this,'',"\c4Trench Cluster Shot \c6- \c4$100 for 3 shots \c6- \c4Item ID: 1");
	messageClient(%this,'',"\c4Dirt Pouch Upgrade \c6- \c4"@%upgradeCost@" to pouch level "@%nextPouchLevel@" \c6- \c4Item ID: 2");
}

function serverCmdTrenchHelp(%client)
{
	messageClient(%client,'',"\c6Trench Help");
	messageClient(%client,'',"\c3To purchase an item, you must be near a miner");
	messageClient(%client,'',"\c3Click on a miner to see their wares, which can be specific to the miner");
	messageClient(%client,'',"\c3To actually buy the item, type \"/buyItem [Item ID]\"");
}

function fxDTSBrick::spawnMinerBot(%this)
{
	if(isObject(%obj = %this.vehicle))
	{
		if(%obj.getClassname() $= "AIPlayer" && %obj.getDatablock().getName() $= "minerStandardArmor" && %obj.spawnBrick == %this)
		{
			%this.wander();
		}
	}
}

function Player::wander(%this)
{
	//do wander stuff
}