function LilDebug(%msg)
{
	if($LilDebug == 1)
	{
		echo(%msg);
	}
}

// ______________
//|              |
//| Server Cmd's |
//|______________|

function serverCmdSpeedDig(%client)
{
	if(%client.isAdmin || %client.isSuperAdmin)
	{
		%client.player.updateArm(AdminShovelImage,0);
		%client.player.mountImage(AdminShovelImage,0);
	}
}
function serverCmdSpeedPlace(%client)
{
	if(%client.isAdmin)
	{
		%client.player.updateArm(AdminDirtImage,0);
		%client.player.mountImage(AdminDirtImage,0);
	}
}
function serverCmdInfiniteDigging(%client)
{
	if(%client.isAdmin)
	{
		if(%client.isInfiniteMiner)
		{
			%client.isInfiniteMiner = 0;
			messageClient(%client,'',"\c3Infinite Digging is now \c6OFF");
			%client.updateDirt();
		}
		else
		{
			if(TrenchDigSO.value["trenchDirtCount",%client.getBLID()] < 1)
			{
				%first = getColorIDTable(0);
				%a = getWord(%first,3) * 255;
				%r = mFloor((getWord(%first,0) * 255) - (255 - %a));
				%g = mFloor((getWord(%first,1) * 255) - (255 - %a));
				%b = mFloor((getWord(%first,2) * 255) - (255 - %a));
				%hex = getHex(%r) @ getHex(%g) @ getHex(%b);
				messageClient(%client,'',"\c3You have no dirt in your inventory, your dirt color will be defaulted to the <color:" @ %hex @ ">first color");
				messageClient(%client,'',"\c3To change this, dig up a dirt brick of any color");
			}
			%client.isInfiniteMiner = 1;
			messageClient(%client,'',"\c3Infinite Digging is now \c6ON");
			%client.updateDirt();
		}
	}
}
function serverCmdDumpDirt(%client)
{
	if(%client.isInfiniteMiner)
	{
		%client.centerPrint("\c3You have infinite digging mode on! Why would you want to dump infinite blocks?",2);
		return;
	}
	%client.dumpedDirt = 0;
	%eyePoint = %client.player.getEyePoint();
	%eyeVector = %client.player.getEyeVector();
	%raycast = containerRayCast(%eyePoint,vectorAdd(%eyePoint,vectorScale(%eyeVector,10)),$TypeMasks::fxBrickObjectType);
	%obj = firstWord(%raycast);
	lilDebug("Fired recast and returned "@%obj);
	if(isObject(%obj))
	{
		%rayPos = posFromRaycast(%raycast);
		%DBName = %obj.getDatablock().getName();
		if(%DBName.isTrenchDirt)
		{
			if(%DBName.isTrenchCube)
			{
				if(TrenchDigSO.value["trenchDirtCount",%client.getBLID()] < 8)
				{
					messageClient(%client,'',"\c3You don't have enough dirt to dump yet.");
					return;
				}
	
				%pos = findSmallBrick(%obj,%rayPos,"brick2xCubeDirtData");
				lilDebug("serverCmdDumpDirt: %pos $= "@%pos);
			
				if(%pos $= "0")
				{
					lilDebug("serverCmdDumpDirt: %pos $= \"0\", returning!");
					return;
				}

				%Normal = normalFromRaycast(%raycast);
				%Scale = vectorScale(%Normal,1);
				%pos = vectorSub(vectorAdd(%pos,%Scale),"0 0 1");

				lilDebug("serverCmdDumpDirt: %pos is now "@%Pos);

				if(%Pos !$= "")
				{
					lilDebug("%Pos !$= \"\"");
					for(%i=0;%i<4;%i++)
					{
						LilDebug("%i == "@%i);
						switch(%i)
						{
							case 0:
								%checkPos = vectorAdd(%Pos,"0.5 0.5 1.5");
							case 1:
								%checkPos = vectorAdd(%Pos,"0.5 -0.5 1.5");
							case 2:
								%checkPos = vectorAdd(%Pos,"-0.5 0.5 1.5");
							case 3:
								%checkPos = vectorAdd(%Pos,"-0.5 -0.5 1.5");
						}
						if(getBrickAtPos(%checkPos,"1.5 1.5 1.5") == 0)
						{
							LilDebug("Woo, found pos at "@%checkPos);
							%add = %checkPos;
							break;
						}
						else
						{
							lilDebug("A brick ("@getBrickAtPos(%checkPos,"1.5 1.5 1.5")@") returned for %i ("@%i@") at pos "@%checkPos);
						}
					}
				}
				else
				{
					lilDebug("Returning?");
					return;
				}
	
				%wholeBricks = mFloor(TrenchDigSO.value["trenchDirtCount",%client.getBLID()] / 8);
	
				%dumpDB = brick4xCubeDirtData;
				%dumpDiv = 8;
				%dumpAdd = 2;
			}
			else
			{
				if(TrenchDigSO.value["trenchDirtCount",%client.getBLID()] < 16)
				{
					messageClient(%client,'',"\c3You don't have enough dirt to dump yet.");
					return;
				}
	
				%pos = findSmallBrick(%obj,%rayPos,"brick1x1DirtData");
				lilDebug("serverCmdDumpDirt: %pos = "@%pos);
				
				if(%pos $= "0")
				{
					lilDebug("serverCmdDumpDirt: %pos $= \"0\", returning!");
					return;
				}
	
				%Normal = normalFromRaycast(%raycast);
				if(getWord(%Normal,2) == 1)
				{
					%up = 1;
				}
				if(%up)
				{
					%scaleVal = 0.6;
				}
				else
				{
					%scaleVal = 0.5;
				}
				%Scale = vectorScale(%Normal,%scaleVal);
	
				%pos = vectorAdd(%pos,%Scale);
	
				LilDebug("New pos is now "@%pos);
	
				for(%x=-0.75;%x<=0.75;%x+=0.5)
				{
					for(%y=-0.75;%y<=0.75;%y+=0.5)
					{
						%possiblePos = vectorAdd(%Pos,%x SPC %y SPC "0");
						if(getBrickAtPos(%possiblePos,"1.9 1.9 0.5") == 0)
						{
							LilDebug("Woo, found pos at "@%possiblePos);
							%Add = %possiblePos;
							%quickStop = 1;
							break;
						}
						else
						{
							LilDebug("A brick ("@getBrickAtPos(%possiblePos,"1.9 1.9 0.5")@") returned for %x,%y at "@%x SPC %y@" at pos "@%possiblePos);
						}
					}
					if(%quickStop)
					{
						break;
					}
				}
	
				%wholeBricks = mFloor(TrenchDigSO.value["trenchDirtCount",%client.getBLID()] / 16);
	
				%dumpDB = brick4x4DirtData;
				%dumpDiv = 16;
				%dumpAdd = 0.6;
			}
	
			%leftOver = TrenchDigSO.value["trenchDirtCount",%client.getBLID()] - %wholeBricks;
			%newPos = %Add;
			for(%i=1;%i<=%wholeBricks;%i++)
			{
				%colorID = getWord(TrenchDigSO.value["trenchDirtList",%client.getBLID()],TrenchDigSO.value["trenchDirtCount",%client.getBLID()] - (mFloor(%i / %dumpDiv) * (%dumpDiv - 1)) - 1);
				%brick = new fxDtsBrick()
				{
					position = %newPos;
					datablock = %dumpDB;
					colorId = %colorID;
					colorFxId = 0;
					shapeFxId = 0;
					client = %obj.getGroup().client;
				};
				%brick.isPlanted = 1;
				%brick.setTrusted(1);
				%Error = %brick.plant();
				if(%Error && %Error != 2)
				{
					lilDebug("D: %error == "@%error);
					%brick.delete();
					%stop = 1;
				}
				if(%stop)
				{
					if(%client.dumpedDirt == 0)
					{
						%client.bottomPrint("\c3You can't dump dirt there!",2);
						%client.schedule(2000,updateDirt);
					}
					else
					{
						%client.bottomPrint("\c3Couldn't finish dumping all of your dirt due to a restriction",2);
						%client.schedule(2000,updateDirt);
					}
					%client.dumpedDirt = 0;
					break;
				}
				%client.dumpedDirt++;
				TrenchDigSO.value["trenchDirtCount",%client.getBLID()] -= %dumpDiv;
				
				%obj.getGroup().add(%brick);
				%newPos = vectorAdd(%newPos,"0 0" SPC %dumpAdd);
				%client.updateDirt();
			}
			TrenchDigSO.value["trenchDirtList",%client.getBLID()] = getWords(TrenchDigSO.value["trenchDirtList",%client.getBLID()],0,TrenchDigSO.value["trenchDirtCount",%client.getBLID()]);
		}
		else
		{
			lilDebug("Not trench dirt");
		}
	}
	else
	{
		lilDebug("Not an object");
	}
}
	
function serverCmdAddDirt(%client,%target,%amt,%colorID)
{
	if(%client.isAdmin)
	{
		%targClient = findClientByName(%target);
		if(isObject(%targClient))
		{
			if(%amt > 0)
			{
				if(!%colorID)
				{
					if(TrenchDigSO.value["trenchDirtCount",%targClient.getBLID()] < 1)
					{
						%colorID = 0;
					}
					else
					{
						%colorID = getWord(TrenchDigSO.value["trenchDirtList",%client.getBLID()],TrenchDigSO.value["trenchDirtCount",%client.getBLID()] - 1);
					}
				}

				TrenchDigSO.value["trenchDirtCount",%targClient.getBLID()] += %amt;
				
				for(%i = 1;%i <= %amt;%i++)
				{
					TrenchDigSO.value["trenchDirtList",%targClient.getBLID()] = trim(TrenchDigSO.value["trenchDirtList",%targClient.getBLID()] SPC %colorID);
				}
				%first = getColorIDTable(%colorID);
				%a = getWord(%first,3) * 255;
				%r = mFloor((getWord(%first,0) * 255) - (255 - %a));
				%g = mFloor((getWord(%first,1) * 255) - (255 - %a));
				%b = mFloor((getWord(%first,2) * 255) - (255 - %a));
				%hex = getHex(%r) @ getHex(%g) @ getHex(%b);

				messageClient(%client,'',"\c3You have given \c6"@%amt@"\c3 dirt to \c6"@%targClient.getPlayerName()@"\c3 with the color id <color:" @ %hex @ ">"@%colorID);
			}
			else
			{
				messageClient(%client,'',"\c3You must specify an amount larger than 0!");
			}
		}
		else
		{
			messageClient(%client,'',"\c3\""@%target@"\" is not in any name for any client in the server!");
		}
	}
	else
	{
		messageClient(%client,'',"\c3You are not an admin! You can't do this!");
	}
}

function serverCmdRemoveDirt(%client,%target,%amt)
{
	if(%client.isAdmin)
	{
		%targClient = findClientByName(%target);
		if(isObject(%targClient))
		{
			if(%amt > 0)
			{
				%amt = mClamp(%amt,1,TrenchDigSO.value["trenchDirtCount",%targClient.getBLID()]);

				TrenchDigSO.value["trenchDirtCount",%targClient.getBLID()] -= %amt;
				
				TrenchDigSO.value["trenchDirtList",%targClient.getBLID()] = getWords(TrenchDigSO.value["trenchDirtList",%targClient.getBLID()],0,(TrenchDigSO.value["trenchDirtCount",%targClient.getBLID()] - 1));

				messageClient(%client,'',"\c3You have removed "@%amt@" dirt from \c6"@%targClient.getPlayerName());
			}
			else
			{
				messageClient(%client,'',"\c3You must specify an amount larger than 0!");
			}
		}
		else
		{
			messageClient(%client,'',"\c3\""@%target@"\" is not within any name for any client in the server!");
		}
	}
	else
	{
		messageClient(%client,'',"\c3You are not an admin! You can't do this!");
	}
}

// ________________
//|                |
//| Main Functions |
//|________________|

function TakeChunk(%client,%take)
{
	%eyePoint = %client.player.getEyePoint();
	%eyeVector = %client.player.getEyeVector();
	%pos = %client.player.getPosition();
	%raycast = containerRayCast(%eyePoint,vectorAdd(%eyePoint,vectorScale(%eyeVector,10)),$TypeMasks::fxBrickObjectType);
	%obj = firstWord(%raycast);
	%rayPos = posFromRaycast(%raycast);
	if(isObject(%obj))
	{
		if(TrenchDigSO.value["trenchDirtCount",%client.getBLID()] < $TrenchDig::dirtCount)
		{
			if(%obj.getDatablock().isTrenchDirt)
			{
				//Fixing getting stuck within new bricks
				%raycast2 = containerRayCast(%pos,vectorAdd(%pos,"0 0 -0.1"),$TypeMasks::fxBrickObjectType,%client.player);
				%obj2 = firstWord(%raycast2);
				if(%obj2 == %obj)
				{
					%client.player.addVelocity("0 0 2");
				}
				%obj.refill(%client,%take,%rayPos);
			}
		}
		else
		{
			%client.centerPrint("\c3You do not have enough room for any more dirt!",1);
		}
	}
}

function ShootChunk(%client)
{
	if(TrenchDigSO.value["trenchDirtCount",%client.getBLID()] <= 0 && !%client.isInfiniteMiner)
	{
		%client.centerPrint("\c3You have no dirt to release!",1);
		return;
	}
	else
	{
		%eyePoint = %client.player.getEyePoint();
		%eyeVector = %client.player.getEyeVector();
		%scale = vectorScale(%eyeVector,10);
		%add = vectorAdd(%eyePoint,%scale);
		%raycast = containerRaycast(%eyePoint,%add,$TypeMasks::FxBrickObjectType);
		%obj = firstWord(%raycast);
		if(isObject(%obj) && %obj.getDatablock().isTrenchDirt)
		{
			%rayPos = posFromRaycast(%raycast);
			%DBName = %obj.getDatablock().getName();
			if(%DBName.isTrenchDirt)
			{
			
				if(%client.isInfiniteMiner && %client.oldTrenchDirt < 1)
				{
					if(%client.defaultTrenchBrickColor $= "")
					{
						%colorID = 0;
					}
					else
					{
						%colorID = %client.defaultTrenchBrickColor;
					}
				}
				else
				{
					%colorID = getWord(TrenchDigSO.value["trenchDirtList",%client.getBLID()],TrenchDigSO.value["trenchDirtCount",%client.getBLID()] - 1);
				}
			
				if(%DBName.isTrenchCube)
				{
					%pos = findSmallBrick(%obj,%rayPos,"brick2xCubeDirtData");
					if(%pos $= "0")
					{
						lilDebug("ShootChunk: %pos $= \"0\", returning!");
						return;
					}
					%Diff = vectorSub(%Pos,%rayPos);
					%else = 1;

					if(getWord(%Diff,2) == 1)
					{
						%Add = vectorSub(%Pos,"0 0 1");
						%else = 0;
					}
					
					if(%else)
					{
						%Normal = normalFromRaycast(%raycast);
						%Scale = vectorScale(%Normal,1);
						%Add = vectorAdd(%Pos,%Scale);
					}
	
					placeDirt(%Add,%colorID,brick2xCubeDirtData,%obj.getGroup().client,%obj.getGroup());
					
					if(!%client.isInfiniteMiner)
					{
						TrenchDigSO.value["trenchDirtCount",%client.getBLID()]--;
						TrenchDigSO.value["trenchDirtList",%client.getBLID()] = removeWord(TrenchDigSO.value["trenchDirtList",%client.getBLID()],TrenchDigSO.value["trenchDirtCount",%client.getBLID()]);
						%client.updateDirt();
					}
				}
				else
				{
					%pos = findSmallBrick(%obj,%rayPos,"brick1x1DirtData");
					if(%pos $= "0")
					{
						lilDebug("ShootChunk: %pos $= \"0\", returning!");
						return;
					}
					%Diff = vectorSub(%pos,%rayPos);
					if(getWord(%Diff,2) == 0.3 || getWord(%Diff,2) >= 0.29)
					{
						%add = getWord(%pos,0) SPC getWord(%pos,1) SPC getWord(vectorSub(%pos,"0 0 0.6"),2);
					}
					else
					{
						%Normal = normalFromRaycast(%raycast);
						%Scale = vectorScale(%Normal,0.5);
						%add = vectorAdd(%pos,%Scale);
					}
	
					placeDirt(%add,%colorID,brick1x1DirtData,%obj.getGroup().client,%obj.getGroup());
	
					if(!%client.isInfiniteMiner)
					{
						TrenchDigSO.value["trenchDirtCount",%client.getBLID()]--;
						TrenchDigSO.value["trenchDirtList",%client.getBLID()] = removeWord(TrenchDigSO.value["trenchDirtList",%client.getBLID()],TrenchDigSO.value["trenchDirtCount",%client.getBLID()]);
						%client.updateDirt();
					}
				}
			}
		}
	}
}

// ___________________
//|                   |
//| Support Functions |
//|___________________|

function placeDirt(%pos,%colorID,%brickDB,%client,%BG)
{
	%brick = new fxDtsBrick()
	{
		position = %pos;
		datablock = %brickDB;
		colorId = %colorID;
		colorFxId = 0;
		shapeFxId = 0;
		client = %client;
	};
	%brick.isPlanted = 1;
	%brick.setTrusted(1);
	%error = %brick.plant();
	if(%error && %error != 2)
	{
		lilDebug("%error is "@%error);
		%brick.delete();
		return;
	}
	%BG.add(%brick);

	%brick.checkBricks(%client);
}

function fxDtsBrick::Refill(%this,%client,%take,%rayPos)
{
	//Changed %size from "64x" to "64"
	//Changed %wantSize from "brick64xCubeDirtData" to "64" and added %wantDB
	//Might be able to optimize this \/\/\/ more
	if(isObject(%this))
	{
		if(%this.getDatablock().isTrenchDirt)
		{
			%size = %this.getDatablock().brickSizeX;
			if((%size > 2 && %this.getDatablock().isTrenchCube) || (%size > 1 && !%this.getDatablock().isTrenchCube))
			{
				%wantSize = %size / 2;
				if(%this.getDatablock().isTrenchCube)
				{
					%wantDB = "brick"@%wantSize@"xCubeDirtData";
				}
				else
				{
					%wantDB = "brick"@%wantSize@"x"@%wantSize@"DirtData";
				}
			}
			else
			{
				if(%take)
				{
					onTrenchDig(%client,%pos,%this);
				}
				return;
			}
		}
		else
		{
			lilDebug("fxDtsBrick::Refill: We are only allowing dirt to be refilled");
			return;
		}
		if(%this.getDatablock().isTrenchCube)
		{
			%isCube = 1;
		}
		else
		{
			%isCube = 0;
		}
		%pos = %this.getPosition();
		%colorId = %this.getColorId();
		%colorFxId = %this.getColorFxId();
		%shapeFxId = %this.getShapeFxId();
		%rotation = %this.rotation;
		if(%client $= "")
		{
			%client = %this.getGroup().client;
		}
		if(%rayPos !$= "")
		{
			%smallPos = findSmallBrick(%this,%rayPos,%wantDB);
			if(%smallPos $= "0")
			{
				lilDebug("fxDtsBrick::refill: %smallPos $= \"0\", returning!");
				return;
			}
		}
		%group = %this.getGroup();
		%this.delete();
		schedule(1,0,fillPos,%pos,%size,%client,%colorId,%colorFx,%shapeFx,%rotation,%group,%isCube);
		if(%rayPos !$= "")
		{
			schedule(5,0,continueRefill,%client,%take,%rayPos,%smallPos);
		}
	}
}
function continueRefill(%client,%take,%rayPos,%smallPos)
{
	%fillBrick = getBrickAtPos(%smallPos,"0 0 0");
	%fillBrick.Refill(%client,%take,%rayPos);
}
function getBrickAtPos(%pos,%box)
{
	InitContainerBoxSearch(%pos,%box,$TypeMasks::fxBrickObjectType);
	%obj = containerSearchNext();
	if(isObject(%obj))
	{
		return %obj;
	}
	else
	{
		return 0;
	}
}

function fillPos(%pos,%size,%client,%colorId,%colorFx,%shapeFx,%rotation,%brickGroup,%isCube)
{
	lilDebug("fillPos called for %size \""@%size@"\"");
	if((%size <= 2 && %isCube) || (%size <= 1 && !%isCube))
	{
		lilDebug("fillPos: We can't fill in dirt, it is already as small as it can get");
		return;
	}
	
	%fillSide = %size / 2;

	%fillMidVal = %fillSide / 4;
	%brickMidVal = %size / 4;

	%extreme = %brickMidVal - %fillMidVal;
	%increment = %fillSide / 2;
	
	if(%isCube)
	{
		%DB = "brick"@%fillSide@"xCubeDirtData";
	}
	else
	{
		%DB = "brick"@%fillSide@"x"@%fillSide@"DirtData";
	}
	lilDebug("fillPos: %DB $= \""@%DB@"\"");
	
	lilDebug("fillPos: Creating bricks - %extreme == "@%exteme@", %increment == "@%increment);
	for(%x=-%extreme;%x<=%extreme;%x+=%increment)
	{
		for(%y=-%extreme;%y<=%extreme;%y+=%increment)
		{
			if(%isCube)
			{
				for(%z=-%extreme;%z<=%extreme;%z+=%increment)
				{
					%newPos = vectorAdd(%pos,%x SPC %y SPC %z);
					%brick = new fxDtsBrick()
					{
						position = %newPos;
						datablock = %DB;
						colorId = %colorId;
						colorFxId = %colorFxId;
						shapeFxId = %shapeFxId;
						client = %brickGroup.client;
					};
					%brick.isPlanted = 1;
					%brick.setTrusted(1);
					%error = %brick.plant();
					if(%error && %error != 2)
					{
						%brick.delete();
					}
					else
					{
						%brickGroup.add(%brick);
					}
				}
			}
			else
			{
				lilDebug("fillPos: Not a cube instance, %z offset will be 0");
				%newPos = vectorAdd(%pos,%x SPC %y SPC "0");
				%brick = new fxDtsBrick()
				{
					position = %newPos;
					datablock = %DB;
					colorId = %colorId;
					colorFxId = %colorFxId;
					shapeFxId = %shapeFxId;
					client = %brickGroup.client;
				};
				%brick.isPlanted = 1;
				%brick.setTrusted(1);
				%error = %brick.plant();
				if(%error && %error != 2)
				{
					%brick.delete();
				}
				else
				{
					%brickGroup.add(%brick);
				}
			}
		}
	}
}

function onTrenchDig(%client,%pos,%brick)
{
	if(TrenchDigSO.value["trenchDirtCount",%client.getBLID()] >= $TrenchDig::DirtCount)
	{
		%client.centerPrint("\c3You do not have enough room for any more dirt!",1);
		return 0;
	}
	else
	{
		if(!%client.isInfiniteMiner)
		{
			TrenchDigSO.value["trenchDirtCount",%client.getBLID()]++;
			TrenchDigSO.value["trenchDirtList",%client.getBLID()] = trim(TrenchDigSO.value["trenchDirtList",%client.getBLID()] SPC %brick.getColorID());
		}
		else if(TrenchDigSO.value["trenchDirtCount",%client.getBLID()] < 1)
		{
			%client.defaultTrenchBrickColor = %brick.getColorID();
		}
		%brick.delete();
		%client.updateDirt();
		return 1;
	}
}

function findSmallBrick(%brick,%pos,%wantBrick)
{
	lilDebug("findSmallBrick called");
	if(!isObject(%brick))
	{
		lilDebug("findSmallBrick: %brick does not exist!");
		return;
	}
	if(isObject(%wantBrick))
	{
		%wantSide = %wantBrick.brickSizeX;
		%brickDB = %brick.getDatablock();
		%brickSide = %brickDB.brickSizeX;
		
		%brickPos = %brick.getPosition();
		
		if(%wantSide > %brickSide)
		{
			lilDebug("findSmallBrick: You can't find a larger brick within a smaller brick!");
			return;
		}
		else if(%wantSide == %brickSide)
		{
			lilDebug("findSmallBrick: %wantSide == %brickSide, returning its own position");
			return %brickPos;
		}
		
		while(%testSide != %wantSide)
		{
			%totalChecks++;
			if(%totalChecks > 100)
			{
				lilDebug("findSmallBrick: Shouldn't take 100 checks, stopping function and returning 0");
				return 0;
			}
		
			%testSide = %brickSide / 2;
			%testMidVal = %testSide / 4;
			%brickMidVal = %brickSide / 4;
			
			lilDebug("%testSide == "@%testSide@", %wantSide == "@%wantSide@", %brickSide == "@%brickSide);
			lilDebug("Checking for small brick \""@%testSide@"\" in \""@%brickSide@"\" at %brickPos \""@%brickPos@"\"");
			
			%extreme = %brickMidVal - %testMidVal;
			%increment = %testSide / 2;
			
			for(%x = -%extreme;%x <= %extreme;%x += %increment)
			{
				for(%y = -%extreme;%y <= %extreme;%y += %increment)
				{
					if(%wantBrick.isTrenchCube)
					{
						for(%z = -%extreme;%z <= %extreme;%z += %increment)
						{
							lilDebug("findSmallBrick: Is a cube");
							%smallPos = vectorAdd(%brickPos,%x SPC %y SPC %z);
							%distance = vectorDist(%pos,%smallPos);
							if(%smallest $= "" || %distance < %smallest)
							{
								%smallestPos = %smallPos;
								%smallest = %distance;
							}
						}
					}
					else
					{
						lilDebug("findSmallBrick: Not a cube");
						%smallPos = vectorAdd(%brickPos,%x SPC %y SPC "0");
						%distance = vectorDist(%pos,%smallPos);
						if(%smallest $= "" || %distance < %smallest)
						{
							%smallestPos = %smallPos;
							%smallest = %distance;
						}
					}
				}
			}
			%brickPos = %smallestPos;
			%brickSide = %testSide;
		}
	}
	if(%smallestPos $= "")
	{
		return 0;
	}
	else
	{
		lilDebug("%smallestPos $= \""@%smallestPos@"\"");
		return %smallestPos;
	}
}

function GameConnection::updateDirt(%this)
{
	if(%this.isInfiniteMiner)
	{
		%Dirt = "";
	}
	else
	{
		%Dirt = TrenchDigSO.value["trenchDirtCount",%this.getBLID()];
	}
	%this.bottomPrint("\c3" @ %Dirt @ "\c6/\c3" @ $TrenchDig::dirtCount @ " dirt",-1);
}


// ______________________
//|                      |
//| Regrouping Functions |
//|______________________|

function fxDtsBrick::checkBricks(%this,%client)
{
	lilDebug("fxDtsBrick::checkBricks called");
	%pos1 = %this.getPosition();
	%DB = %this.getDatablock();
	%data = %this.getDatablock();
	
	if(%DB.isTrenchDirt)
	{
		%brickSize = %DB.brickSizeX;
		%checkSize = %brickSize / 2;
		%div = 4 / %brickSize;
		
		lilDebug("fxDtsBrick::checkBricks: %checkSize $= \""@%checkSize@"\"");
		
		%brickSizeZ = %DB.isTrenchCube ? %brickSize: %brickSize * 0.2 + 0.3;
		%box = (%brickSize * 0.5 + 0.6) SPC (%brickSize * 0.5 + 0.6) SPC %brickSizeZ;
		
		InitContainerBoxSearch(%pos1,%box,$TypeMasks::fxBrickObjectType);

		%puzzleComplete = 0;
		%puzzlePos = "0 0 0";
		lilDebug("fxDtsBrick::checkBricks: Started up the container search...");
		while(isObject(%next = containerSearchNext()))
		{
			lilDebug("%next is an object, "@%next);
			if(%next.getDatablock() == %DB && %next.isPlanted && %next.getDatablock().isTrenchDirt)
			{
				lilDebug("%next is the same brick, and it is dirt");
				%pos2 = %next.getPosition();
				%sub = vectorSub(%pos1,%pos2);
				if(%DB.isTrenchCube)
				{
					lilDebug("%DB is cube dirt");
					switch$(%sub)
					{
						case %checkSize SPC "0 0":
							%puzzleComplete++;
							%smallBrick[1,0,0] = %next;
							%puzzleDir[1,-1,1] += 1;
							%puzzleDir[1,1,1] += 1;
							%puzzleDir[1,-1,-1] += 1;
							%puzzleDir[1,1,-1] += 1;
						case -%checkSize SPC "0 0":
							%puzzleComplete++;
							%smallBrick[-1,0,0] = %next;
							%puzzleDir[-1,1,1] += 1;
							%puzzleDir[-1,-1,1] += 1;
							%puzzleDir[-1,1,-1] += 1;
							%puzzleDir[-1,-1,-1] += 1;
						case "0" SPC %checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[0,1,0] = %next;
							%puzzleDir[1,1,1] += 1;
							%puzzleDir[-1,1,1] += 1;
							%puzzleDir[1,1,-1] += 1;
							%puzzleDir[-1,1,-1] += 1;
						case "0" SPC -%checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[0,-1,0] = %next;
							%puzzleDir[1,-1,1] += 1;
							%puzzleDir[-1,-1,1] += 1;
							%puzzleDir[1,-1,-1] += 1;
							%puzzleDir[-1,-1,-1] += 1;
						case %checkSize SPC %checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[1,1,0] = %next;
							%puzzleDir[1,1,-1] += 1;
							%puzzleDir[1,1,1] += 1;
						case %checkSize SPC -%checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[1,-1,0] = %next;
							%puzzleDir[1,-1,1] += 1;
							%puzzleDir[1,-1,-1] += 1;
						case -%checkSize SPC %checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[-1,1,0] = %next;
							%puzzleDir[-1,1,1] += 1;
							%puzzleDir[-1,1,-1] += 1;
						case -%checkSize SPC -%checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[-1,-1,0] = %next;
							%puzzleDir[-1,-1,1] += 1;
							%puzzleDir[-1,-1,-1] += 1;
		
						case %checkSize SPC "0" SPC %checkSize:
							%puzzleComplete++;
							%smallBrick[1,0,1] = %next;
							%puzzleDir[1,-1,1] += 1;
							%puzzleDir[1,1,1] += 1;
						case -%checkSize SPC "0" SPC %checkSize:
							%puzzleComplete++;
							%smallBrick[-1,0,1] = %next;
							%puzzleDir[-1,1,1] += 1;
							%puzzleDir[-1,-1,1] += 1;
						case "0" SPC %checkSize SPC %checkSize:
							%puzzleComplete++;
							%smallBrick[0,1,1] = %next;
							%puzzleDir[1,1,1] += 1;
							%puzzleDir[-1,1,1] += 1;
						case "0" SPC -%checkSize SPC %checkSize:
							%puzzleComplete++;
							%smallBrick[0,-1,1] = %next;
							%puzzleDir[1,-1,1] += 1;
							%puzzleDir[-1,-1,1] += 1;
						case %checkSize SPC %checkSize SPC %checkSize:
							%puzzleComplete++;
							%smallBrick[1,1,1] = %next;
							%puzzleDir[1,1,1] += 1;
						case %checkSize SPC -%checkSize SPC %checkSize:
							%puzzleComplete++;
							%smallBrick[1,-1,1] = %next;
							%puzzleDir[1,-1,1] += 1;
						case -%checkSize SPC %checkSize SPC %checkSize:
							%puzzleComplete++;
							%smallBrick[-1,1,1] = %next;
							%puzzleDir[-1,1,1] += 1;
						case -%checkSize SPC -%checkSize SPC %checkSize:
							%puzzleComplete++;
							%smallBrick[-1,-1,1] = %next;
							%puzzleDir[-1,-1,1] += 1;
						case "0 0" SPC %checkSize:
							%puzzleComplete++;
							%smallBrick[0,0,1] = %next;
							%puzzleDir[1,1,1] += 1;
							%puzzleDir[-1,1,1] += 1;
							%puzzleDir[-1,-1,1] += 1;
							%puzzleDir[1,-1,1] += 1;
		
						case %checkSize SPC "0" SPC -%checkSize:
							%puzzleComplete++;
							%smallBrick[1,0,-1] = %next;
							%puzzleDir[1,-1,-1] += 1;
							%puzzleDir[1,1,-1] += 1;
						case -%checkSize SPC "0" SPC -%checkSize:
							%puzzleComplete++;
							%smallBrick[-1,0,-1] = %next;
							%puzzleDir[-1,1,-1] += 1;
							%puzzleDir[-1,-1,-1] += 1;
						case "0" SPC %checkSize SPC -%checkSize:
							%puzzleComplete++;
							%smallBrick[0,1,-1] = %next;
							%puzzleDir[1,1,-1] += 1;
							%puzzleDir[-1,1,-1] += 1;
						case "0" SPC -%checkSize SPC -%checkSize:
							%puzzleComplete++;
							%smallBrick[0,-1,-1] = %next;
							%puzzleDir[1,-1,-1] += 1;
							%puzzleDir[-1,-1,-1] += 1;
						case %checkSize SPC %checkSize SPC -%checkSize:
							%puzzleComplete++;
							%smallBrick[1,1,-1] = %next;
							%puzzleDir[1,1,-1] += 1;
						case %checkSize SPC -%checkSize SPC -%checkSize:
							%puzzleComplete++;
							%smallBrick[1,-1,-1] = %next;
							%puzzleDir[1,-1,-1] += 1;
						case -%checkSize SPC %checkSize SPC -%checkSize:
							%puzzleComplete++;
							%smallBrick[-1,1,-1] = %next;
							%puzzleDir[-1,1,-1] += 1;
						case -%checkSize SPC -%checkSize SPC -%checkSize:
							%puzzleComplete++;
							%smallBrick[-1,-1,-1] = %next;
							%puzzleDir[-1,-1,-1] += 1;
						case "0 0" SPC -%checkSize:
							%puzzleComplete++;
							%smallBrick[0,0,-1] = %next;
							%puzzleDir[1,1,-1] += 1;
							%puzzleDir[-1,1,-1] += 1;
							%puzzleDir[-1,-1,-1] += 1;
							%puzzleDir[1,-1,-1] += 1;
							
						default:
							lilDebug("Default called!");
					}
				}
				else
				{
					lilDebug("%next is not a cube");
					switch$(%sub)
					{
						case %checkSize SPC "0 0":
							%puzzleComplete++;
							%smallBrick[1,0] = %next;
							%puzzleDir[1,-1] += 1;
							%puzzleDir[1,1] += 1;
						case -%checkSize SPC "0 0":
							%puzzleComplete++;
							%smallBrick[-1,0] = %next;
							%puzzleDir[-1,1] += 1;
							%puzzleDir[-1,-1] += 1;
						case "0" SPC %checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[0,1] = %next;
							%puzzleDir[1,1] += 1;
							%puzzleDir[-1,1] += 1;
						case "0" SPC -%checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[0,-1] = %next;
							%puzzleDir[1,-1] += 1;
							%puzzleDir[-1,-1] += 1;
						case %checkSize SPC %checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[1,1] = %next;
							%puzzleDir[1,1] += 1;
						case %checkSize SPC -%checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[1,-1] = %next;
							%puzzleDir[1,-1] += 1;
						case -%checkSize SPC %checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[-1,1] = %next;
							%puzzleDir[-1,1] += 1;
						case -%checkSize SPC -%checkSize SPC "0":
							%puzzleComplete++;
							%smallBrick[-1,-1] = %next;
							%puzzleDir[-1,-1] += 1;
						default:
							lilDebug("Default called!");
					}
				}
			}
			else
			{
				lilDebug("fxDtsBrick::checkBricks: Found a brick \""@%next.getDatablock().getName()@"\"");
				lilDebug("fxDtsBrick::checkBricks: ^Brick is planted? \""@%next.isPlanted@"\"");
			}
		}
		lilDebug("fxDtsBrick::checkBricks: Did container check, %puzzleComplete is "@%puzzleComplete);
		if(%DB.isTrenchCube)
		{
			if(%puzzleComplete >= 7)
			{
				lilDebug("Found "@%puzzleComplete@" bricks surrounding");
				lilDebug("Checking which direction to use...");
				for(%a = -1;%a <= 1;%a++)
				{
					for(%b = -1;%b <= 1;%b++)
					{
						for(%c = -1;%c <= 1;%c++)
						{
							%cur = %puzzleDir[%a,%b,%c];
							if(%highest $= "" || %cur > %highest)
							{
								%highest = %cur;
								%highA = %a;
								%highB = %b;
								%highC = %c;
							}
						}
					}
				}
				if(%highest < 7)
				{
					lilDebug("The highest in one direction is "@%highest);
					lilDebug("Aren't enough bricks to make the desired grouping...");
					return;
				}
				lilDebug("Got the highest direction...");
				%pos = vectorAdd(%this.getPosition(),%highA/%div*-1 SPC %highB/%div*-1 SPC %highC/%div*-1);
				%BGClient = %this.getGroup().client;
				%BG = %this.getGroup();

				%bColor[%this.getColorID()]++;
				%bColor[%smallBrick[%highA,0,0].getColorID()]++;
				%bColor[%smallBrick[0,%highB,0].getColorID()]++;
				%bColor[%smallBrick[%highA,%highB,0].getColorID()]++;
				%bColor[%smallBrick[%highA,0,%highC].getColorID()]++;
				%bColor[%smallBrick[0,%highB,%highC].getColorID()]++;
				%bColor[%smallBrick[%highA,%highB,%highC].getColorID()]++;
				%bColor[%smallBrick[0,0,%highC].getColorID()]++;
				for(%i=0;%i<64;%i++)
				{
					%currColor = %bColor[%i];
					if(%majorColor $= "" || %currColor > %majorCount)
					{
						%majorCount = %currColor;
						%majorColor = %i;
					}
				}
				
				%this.schedule(0,delete);
				%smallBrick[%highA,0,0].schedule(0,delete);
				%smallBrick[0,%highB,0].schedule(0,delete);
				%smallBrick[%highA,%highB,0].schedule(0,delete);
				%smallBrick[%highA,0,%highC].schedule(0,delete);
				%smallBrick[0,%highB,%highC].schedule(0,delete);
				%smallBrick[%highA,%highB,%highC].schedule(0,delete);
				%smallBrick[0,0,%highC].schedule(0,delete);
				lilDebug("Deleted the bricks...");
				
				schedule(%sched,0,finishRegrouping,%pos,%DB,%majorColor,%BGclient,%BG,%client);
			}
		}
		else
		{
			if(%puzzleComplete >= 3)
			{
				lilDebug("Found "@%puzzleComplete@" bricks surrounding...");
				for(%a = -1;%a <= 1;%a++)
				{
					for(%b = -1;%b <= 1;%b++)
					{
						%cur = %puzzleDir[%a,%b];
						if(%highest $= "" || %cur > %highest)
						{
							%highest = %cur;
							%highA = %a;
							%highB = %b;
						}
					}
				}
				if(%highest < 3)
				{
					lilDebug("Aren't enough bricks to make the desired grouping...");
					return;
				}
				lilDebug("Got the highest direction...");
				%pos = vectorAdd(%this.getPosition(),%highA/%div*-1 SPC %highB/%div*-1 SPC "0");
				%BGClient = %this.getGroup().client;
				%BG = %this.getGroup();

				%bColor[%this.getColorID()]++;
				%bColor[%smallBrick[%highA,0].getColorID()]++;
				%bColor[%smallBrick[%highA,%highB].getColorID()]++;
				%bColor[%smallBrick[0,%highB].getColorID()]++;
				for(%i=0;%i<64;%i++)
				{
					%currColor = %bColor[%i];
					if(%majorColor $= "" || %currColor > %majorCount)
					{
						%majorCount = %currColor;
						%majorColor = %i;
					}
				}

				%this.delete();
				%smallBrick[%highA,0].delete();
				%smallBrick[0,%highB].delete();
				%smallBrick[%highA,%highB].delete();
				lilDebug("Deleted the bricks...");

				schedule(1,0,finishRegrouping,%pos,%DB,%majorColor,%BGClient,%BG,%client);
			}
		}
	}
	else
	{
		lilDebug("fxDtsBrick::checkBricks: %DB is not trench dirt");
	}
}

function finishRegrouping(%pos,%DB,%colorID,%client,%BG,%difClient)
{
	if(%DB.getName() $= "brick2xCubeDirtData")
	{
		%DB = brick4xCubeDirtData;
	}
	else if(%DB.getName() $= "brick4xCubeDirtData")
	{
		%DB = brick8xCubeDirtData;
	}
	else if(%DB.getName() $= "brick8xCubeDirtData")
	{
		%DB = brick16xCubeDirtData;
	}
	else if(%DB.getName() $= "brick16xCubeDirtData")
	{
		%DB = brick32xCubeDirtData;
	}
	else if(%DB.getName() $= "brick32xCubeDirtData")
	{
		%DB = brick64xCubeDirtData;
	}
	else if(%DB.getName() $= "brick1x1DirtData")
	{
		%DB = brick2x2DirtData;
	}
	else if(%DB.getName() $= "brick2x2DirtData")
	{
		%DB = brick4x4DirtData;
	}
	else if(%DB.getName() $= "brick4x4DirtData")
	{
		%DB = brick8x8DirtData;
	}
	else if(%DB.getName() $= "brick8x8DirtData")
	{
		%DB = brick16x16DirtData;
	}
	%newBrick = new fxDtsBrick()
	{
		position = %pos;
		datablock = %DB;
		colorId = %colorId;
		client = %client;
		colorFxId = 0;
		shapeFxId = 0;
	};
	%newBrick.isPlanted = 1;
	%newBrick.setTrusted(1);
	%error = %newBrick.plant();
	lilDebug("Called .plant() and it returned: "@ %error);
	if(%error && %error != 2)
	{
		%newBrick.delete();
		return;
	}
	%BG.add(%newBrick);

// Fixing getting stuck within the brick
	lilDebug("Attempting to launch player up a bit");
	if(isObject(%client.player))
	{
		%pos = %client.player.getPosition();
		%raycast = containerRayCast(%pos,vectorAdd(%pos,"0 0 -0.1"),$TypeMasks::fxBrickObjectType,%client.player);
		%obj = firstWord(%raycast);
		if(%obj == %newBrick)
		{
			%client.player.addVelocity("0 0 3");
		}
		else
		{
			lilDebug("Apparently player is not looking at the new brick. %obj is "@%obj);
		}
	}
	else
	{
		lilDebug("Player does not exist!");
	}

	lilDebug("All was successful! Checking for more groupage...");

	%newBrick.schedule(2,checkBricks);
}


// ______________________
//|                      |
//|  Support Functions   |
//|______________________|

//Credits to Clockturn for his conversion to hex functions

function getHex(%power)

{

	%first = 0;

	%last = 0;

	while(%power > 0)

	{

		if(%power > 16)

		{

			%first++;

			%power -= 16;

			continue;

		}

		%last++;

		%power--;

	}

	switch(%first)

	{

	case 10:

		%first = "A";

	case 11:

		%first = "B";

	case 12:

		%first = "C";

	case 13:

		%first = "D";

	case 14:

		%first = "E";

	case 15:

		%first = "F";

	}

	switch(%last)

	{

	case 10:

		%last = "A";

	case 11:

		%last = "B";

	case 12:

		%last = "C";

	case 13:

		%last = "D";

	case 14:

		%last = "E";

	case 15:

		%last = "F";

	}

	return %first @ %last;

}